=== debian/control ===
Source: ros-melodic-trac-ik-python
Section: misc
Priority: extra
Maintainer: Sam Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-rospy, ros-melodic-tf-conversions, ros-melodic-trac-ik-lib, swig
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-trac-ik-python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-rospy, ros-melodic-tf, ros-melodic-tf-conversions, ros-melodic-trac-ik-lib, swig
Description: The trac_ik_python package contains a python wrapper using SWIG for trac_ik_lib
